<?php
/*
Helper functions for the small stats pages. Mainly fixes of functions used to fix the relative
path to a fixed one.

Auther: Rolf Koedam (alias kE)
Based on: UTStats Beta 4.2  2005 azazel, AnthraX and toa
*/

global $url_fix;
$url_fix = 'http://www.yourhost.com/stats';

function FlagImageFix($country, $mini = true) {
	global $a_countries, $url_fix;
	$width = ($mini) ? 15 : 18;
	$height = ($mini) ? 10 : 12;
	if (empty($country)) return('');
	
	$handle = @fopen($url_fix."/images/flags/".$country.".png", "r");
 	if ($handle === false)
  		return(''); //18*12
  	
 	fclose($handle);
	
	$countryname = (isset($a_countries[$country])) ? $a_countries[$country] : '';
	return('<img src="'.$url_fix.'/images/flags/'. $country .'.png" width="'.$width.'" height="'.$height.'" style="border:0;" alt="'. $country .'" title="'. $countryname .'">');
}

function RankMovementFix($diff) {
	global $url_fix;
	$diff = round($diff, 2);
	if ($diff == 0) {
		$chimg = 'same';
		$chtext = "ranking not affected";
	}
	if ($diff > 0) {
		$chimg = 'up';
		$chtext = "gained ". get_dp($diff) ." ranking points";
	}
	if ($diff < 0) {
		$chimg = 'down';
		$chtext = "lost ". get_dp($diff * -1) ." ranking points";
	}
	$handle = @fopen($url_fix."/images/ranks/$chimg.png", "r");
 	if ($handle === false)
  		return(''); //18*12
  	
 	fclose($handle);
 	$infos = getimagesize($url_fix."/images/ranks/$chimg.png");
	$width = $infos[0];
	$height = $infos[1];
	
	return('<img src="'.$url_fix.'/images/ranks/'. $chimg .'.png" width="'.$width.'" height="'.$height.'" style="border:0;" alt="" title="'. $chtext .'">');
}

function RankImageOrTextFix($pid, $name, $rank, $gid, $gamename, $mini = true, $format = NULL, $rankchange = NULL) {
	global $url_fix;
	$points = 0;
	if (empty($rank)) {
		$r_rank = small_query("SELECT rank FROM uts_rank WHERE pid = '$pid' AND gid= '$gid';");
		if (!$r_rank) return('');
		$points = get_dp($r_rank['rank']);
		$r_no = small_query("SELECT (COUNT(*) + 1) AS no FROM uts_rank WHERE gid = '$gid' and rank > ${points}9");
		$rank = $r_no['no'];
	}

	$ranktext = $rank.ordinal($rank);
	$handle = @fopen($url_fix."/images/ranks/".$rank.".png", "r");
 	if ($handle === FALSE) {
		$img = '';
	} else {
		$width = ($mini) ? 14 : 16;
		$height = ($mini) ? 10 : 13;
		$img = '<img src='.$url_fix.'/images/ranks/'. $rank .'.png" width="'.$width.'" height="'.$height.'" style="border:0;" alt="'. $rank .'" title="'. $ranktext .' in '. $gamename .'">';
	} 
	$moveimg = '';
	if ($rankchange !== NULL) {
		$moveimg =  ' '. RankMovementFix($rankchange);
	}
	

	if (empty($format)) {
		if ($img) {
			return($img.$moveimg);
		} else {
			return('<span class="rangtext">('.$ranktext.$moveimg.')</span>');
		}
	}
	$imageortext = ($img) ? $img : $ranktext;
	$search  = array('%RT%', 		'%RN%',	'%RP%',	'%RI%',	'%GN%',		'%PN%',	'%IT%');
	$replace = array($ranktext,	$rank,	$points,	$img,		$gamename,	$name,	$imageortext);
	return(str_replace($search, $replace, $format));
}

?>