<?php

/*
Small script that outputs the query made to the server; used for debugging

Auther: Rolf Koedam (alias kE)
Based on: UT Query PHP script v1.2 by Almar Joling, 2003
*/
$G_serverip = "xxx.xxx.xxx.xxx:xxxx";


// Get server IP info
list($serverip, $serverport) = split(":", $G_serverip);
$queryport = $serverport+1;

//If there is no IP, return (exit)
if (strlen($serverip) == 0) {
	echo "error1!";
	return;
}

//Open UDP socket to server
$sock = fsockopen("udp://" . $serverip, $queryport, $errno, $errstr,4);

//Check if we have a socket open, if not, display error message
if (!$sock) {
	echo "$errstr ($errno)<br>\n";
	exit;
}

fputs($sock,"\\status\\\game_property\ElapsedTime\\\game_property\RemainingTime\\\\teams\\");

$gotfinal = False;
$data = "";

//Set starttime, for possible loop expiration, so the server doesn't get too much work.
$starttime = Time();

//Loop until final packet has been received.
while(!($gotfinal == True || feof($sock))) {
	//Get data
	if(($buf = fgetc($sock)) == FALSE) {
		usleep(100); // wait for additional data? :S whatever
	}
	//Add to databuffer
	$data .= $buf;
	//Check if final item (queryid) has been received
	if (strpos($data,"final\\") != False) {
		$gotfinal = True;
	}
	//Protect webserver against massive loop.
	if ((Time() - $starttime) > 5) {
		echo "Data receiving took too long. Cancelled.<P>";
		$gotfinal = True;
	}
}

//Close socket
fclose ($sock);


//Split chunks by \
$chunks = split('[\]', $data);

for($i = 0; $i<count($chunks);$i++) {
	echo $i." ".$chunks[$i]."<BR>";
}

?>
