<?php 

/*
Small script that parses the xml output from the xml query script and outputs html.

Auther: Rolf Koedam (alias kE)
Based on: UT Query PHP script v1.2 by Almar Joling, 2003
Uses: XMLParser by Adam A Flynn
*/

include_once("classes/XMLParser.php");
include_once("classes/StatsIntegration.php");
global $url_fix;
$parse_url = "http://www.yourhost.com/query/xml.php";

// Helper functions
function GetColorValue($teamid) {
	$retval = "#DBDBDB";
	$colors = array("#f05152","#57a0d7","#90FF87","#FEFF91");	
	if ($teamid < 4) $retval = $colors[$teamid];
	return $retval;	
}

function  GetColorValueTeam($teamname) {
	$retval = "#DBDBDB";
	$colors = array("#f05152","#57a0d7","#90FF87","#FEFF91");
	$teams = array('Red' => 0,'Blue' => 1,'Green' => 2,'Gold' => 3);
	if (array_key_exists($teamname,$teams)) $retval = $colors[$teams[$teamname]];
	return $retval;	
}

//Prepares a string to be shown in html
//@return the resulting string
function show($string) {
    if(is_string($string)) {
        $string = trim($string);
        $string = htmlspecialchars($string);
    }
    return $string;
}

//Destrips text (\' --> ')
//@return $string without the extra slashes etc.
function show_text($string) {
    if(is_string($string)) {
        $string = htmlspecialchars($string);
        $string = str_replace("F_ENTER", "\n", $string);
    }
    return $string;
}

if($status_xml = file_get_contents($parse_url)) {
	$xml = new XMLParser($status_xml);
	$xml->Parse();
	
	$mapname = $xml->document->serverinfo[0]->mapname[0]->tagData;
	
	// Check if screenshot is available in url/images/maps/
	$mappic = $url_fix."/images/maps/".strtolower($mapname).".jpg";
	$handle = @fopen($mappic, "r");
	// If it doesn't, use a blank one ;)
	if ($handle === FALSE) {
	   $mappic = ($url_fix."/images/maps/blank.jpg");
	}
	
	
	$mapurl = $mapname;
	$mapimg = '<img height="170" alt="'.$mapname.'" title="'.$mapname.'" src="'.$mappic.'">';

	$r_hostname = show_text($xml->document->serverinfo[0]->hostname[0]->tagData);
	$r_gametype = show_text($xml->document->serverinfo[0]->gametype[0]->tagData);
	$r_timelimit = show_text($xml->document->serverinfo[0]->timelimit[0]->tagData . " mins");
	$r_remainingtime = show_text($xml->document->serverinfo[0]->remainingtime[0]->tagData  . " mins");
	$r_elapsedtime = show_text($xml->document->serverinfo[0]->elapsedtime[0]->tagData . " mins");
	$r_goalteamscore = show_text($xml->document->serverinfo[0]->goalteamscore[0]->tagData);
	$r_numplayers = show_text($xml->document->serverinfo[0]->numplayers[0]->tagData);
	$r_maxplayers = show_text($xml->document->serverinfo[0]->maxplayers[0]->tagData);
	$r_maxteams = show_text($xml->document->serverinfo[0]->maxteams[0]->tagData);
	
	$r_mutators = show_text($xml->document->serverinfo[0]->mutators[0]->tagData);
	
	//Loop through all teams
	if($r_maxteams > 0) {
		$result_teams = '
		<P><BR></P>
		<P class=q_title>Teams</P>
		<P><TABLE class=q_info>
		<TR>
		<TD></TD>
		<TD class=q_entry><B># Players</B></TD>
		<TD class=q_entry><B># Caps</B></TD>
		</TR>';
	
		for ($i = 0; $i < $r_maxteams; $i++) {
			$actualid = $i;
			$itemx = $i+1;
		
			$r_teamcolor = show_text($xml->document->teams[0]->team[$i]->color[0]->tagData);
			$rowcolor = GetColorValueTeam($r_teamcolor);
			$r_teamsize = show_text($xml->document->teams[0]->team[$i]->size[0]->tagData);
			$r_teamscore = show_text($xml->document->teams[0]->team[$i]->score[0]->tagData);
		
			$result_teams .= '<TR>
				<td style="vertical-align: middle; margin: 3px 5px; padding: 1px 5px 1px 5px; font-size: 11px; background: '.$rowcolor.';">'.$r_teamcolor.'</td>
				<td style="vertical-align: middle; margin: 3px 5px; padding: 1px 5px 1px 5px; font-size: 11px; text-align: right; background: '.$rowcolor.';">'.$r_teamsize.'</td>
				<td style="vertical-align: middle; margin: 3px 5px; padding: 1px 5px 1px 5px; font-size: 11px; text-align: right; background: '.$rowcolor.';">'.round($r_teamscore,0).'</td>
			  	</TR>';
		}
		$result_teams .=  '</TABLE>';
	}
	
	if($r_numplayers > 0) {
		$result_players = '
	<P><BR></P>
	<P class=q_title>Players</P>
	<P><TABLE class=q_info>
	<TR>
	<TD class=q_entry><B>Player</B></TD>
	<TD class=q_entry><B>Frags</B></TD>
	<TD class=q_entry><B>Team</B></TD>
	<TD class=q_entry><B>Ping</B></TD>
	<TD></TD>
	</TR>';
	
		for ($i = 0; $i < $r_numplayers; $i++) {
			$actualid = $i;
			$itemx = $i+1;
		
			$r_playername = $xml->document->players[0]->player[$i]->nick[0]->tagData;

			// Check if user is known in stats
			$nickname_html = file_get_contents($url_fix."/pages/small_search.php?name=".$r_playername);
			if(hasValue($nickname_html) && $nickname_html != "none") {
				$pid = show($nickname_html);
				$r_playername = "<A class=q_link HREF=\"$url_fix/?p=pinfo&amp;pid=$pid\">".show($r_playername)."</A>";
			} else {
				$r_playername = show($r_playername);
			}
			
			$r_playerfrags = show_text($xml->document->players[0]->player[$i]->frags[0]->tagData);
			$r_playerteam = show_text($xml->document->players[0]->player[$i]->team[0]->tagData);
			$r_playerping = show_text($xml->document->players[0]->player[$i]->ping[0]->tagData);
			$rowcolor = GetColorValue($xml->document->players[0]->player[$i]->team[0]->tagData);
		
			$result_players .= '<TR>
				<td style="vertical-align: middle; margin: 3px 5px; width: 200px; padding: 1px 5px 1px 5px; font-size: 11px; background: '.$rowcolor.';">'.$r_playername.'</td>
				<td style="vertical-align: middle; margin: 3px 5px; padding: 1px 5px 1px 5px; font-size: 11px; text-align: right; background: '.$rowcolor.';">'.$r_playerfrags.'</td>
				<td style="vertical-align: middle; margin: 3px 5px; padding: 1px 5px 1px 5px; font-size: 11px; text-align: right; background: '.$rowcolor.';">'.$r_playerteam.'</td>
				<td style="vertical-align: middle; margin: 3px 5px; padding: 1px 5px 1px 5px; font-size: 11px; text-align: right; background: '.$rowcolor.';">'.$r_playerping.'</td>
			  	</TR>';
		}
		$result_players .=  '</TABLE>';
	}	
	
	// Echo server info
	echo'
	<P class=post_title>'.$r_hostname.' status</P>
	<P><TABLE class=q_info><TR>
	<TD><TABLE>
	<TR><TD><B>Map:</B></TD><TD>'.$mapurl.'</TD></TR>
	<TR><TD><B>GameType:</B></TD><TD>'.$r_gametype.'</TD></TR>
	<TR><TD><B>Mutators:</B></TD><TD>'.$r_mutators.'</TD></TR>
	<TR><TD><B>Goal Caps:</B></TD><TD>'.$r_goalteamscore.'</TD></TR>
	<TR><TD><B>Current Players:</B></TD><TD>'.$r_numplayers.'</TD></TR>
	<TR><TD><B>Max Players:</B></TD><TD>'.$r_maxplayers.'</TD></TR>
	<TR><TD><B>Max Teams:</B></TD><TD>'.$r_maxteams.'</TD></TR>
	<TR><TD><B>Time Limit:</B></TD><TD>'.$r_timelimit.'</TD></TR>
	<TR><TD><B>Time Remaining:</B></TD><TD>'.$r_remainingtime.'</TD></TR>
	</TABLE></TD>
	<TD>'.$mapimg.'</TD>
	</TR></TABLE>';
	echo $result_teams;
	echo $result_players;

}
?>
