<?php
/*
Small script that outputs some playerinfo. Returns "none" if playerid is unknown.
Usage: small_pinfo.php?pid=xxx

Auther: Rolf Koedam (alias kE)
Based on: UTStats Beta 4.2  2005 azazel, AnthraX and toa
*/

include_once("../../classes/StatsIntegration.php");
include ("../includes/config.php");
include ("../includes/functions.php");

global $url_fix;

//Strips a string (not text!) to prevent hacks
//@return $string without the disallowed chars/strings
function store($string) {
    if(is_string($string)) {
        $nasty_chars = array(" ");
        $string = str_replace($nasty_chars, "", $string);
        $string = mysql_real_escape_string($string);
    }
    return $string;
}

$pid = store($_GET['pid']);

$r_info = small_query("SELECT name, country, banned FROM uts_pinfo WHERE id = '$pid'");
if (!$r_info) {
	echo "none";
} else if ($r_info['banned'] == 'Y') {
	echo "none";
} else {
	
	$playername = $r_info['name'];
	
	$result = '<BR><P class=q_title>Server stats</P><P><TABLE>';
	$result .= '<TR><TD><B>Server nickname:</B></TD><TD class=q_entry>'.FlagImageFix($r_info['country'], false).' '.htmlentities($playername).'</TD></TR>';
	
	$r_sumplist = small_query("SELECT SUM(kills) AS kills, SUM(deaths) AS deaths, SUM(suicides) AS suicides, SUM(teamkills) AS teamkills, SUM(kills+deaths+suicides+teamkills) AS sumeff, COUNT(id) AS games, SUM(gametime) as gametime FROM uts_player WHERE pid = '$pid'");
	
	$gametime = sec2hour($r_sumplist[gametime]);
	$gamedays = floor($r_sumplist[gametime]/(24*60*60));
	if($gamedays > 1) $gamedays = $gamedays." days, ";
	else if($gamedays == 1) $gamedays = $gamedays." day, ";
	else $gamedays = "";
	$gamehours = floor(($r_sumplist[gametime]%(24*60*60))/(60*60));
	if($gamehours > 1) $gamehours = $gamehours." hours, ";
	else if($gamehours == 1) $gamehours = $gamehours." hour, ";
	else $gamehours = "";
	$gameminutes = floor(($r_sumplist[gametime]%(24*60))/(60));
	if($gameminutes > 1) $gameminutes = $gameminutes." minutes";
	else if($gameminutes == 1) $gameminutes = $gameminutes." minute";
	else $gameminutes = "";
	$eff = get_dp($r_sumplist[kills]/$r_sumplist[sumeff]*100);
	
	$result .= '<TR><TD><B>Average effi</B></TD><TD class=q_entry>'.$eff.'%</TD></TR>';
	$result .= '<TR><TD><B>Total games</B></TD><TD class=q_entry>'.$r_sumplist[games].'</TD></TR>';
	$result .= '<TR><TD><B>Total gametime</B></TD><TD class=q_entry>'.$gametime.' hours ('.$gamedays.$gamehours.$gameminutes.')</TD></TR>';
	
	
	$sql_cdatot = zero_out(small_query("SELECT SUM(flag_assist) AS flag_assist, SUM(flag_capture) AS flag_capture, SUM(flag_kill)as flag_kill FROM uts_player WHERE pid = '$pid'"));
	
	$result .= '<TR><TD><B>Total/Avg flag captures</B></TD><TD class=q_entry>'.$sql_cdatot[flag_capture].' / '.round(($sql_cdatot[flag_capture]/$r_sumplist[games]),1).'</TD></TR>';
	$result .= '<TR><TD><B>Total/Avg flag assists</B></TD><TD class=q_entry>'.$sql_cdatot[flag_assist].' / '.round(($sql_cdatot[flag_assist]/$r_sumplist[games]),1).'</TD></TR>';
	$result .= '<TR><TD><B>Total/Avg flag kills</B></TD><TD class=q_entry>'.$sql_cdatot[flag_kill].' / '.round(($sql_cdatot[flag_kill]/$r_sumplist[games]),1).'</TD></TR>';
	
	$sql_rank = "SELECT g.name AS gamename, r.rank, r.prevrank, r.matches, r.gid, r.pid FROM uts_rank AS r, uts_games AS g WHERE r.gid = g.id AND r.pid = '$pid';";
	$q_rank = mysql_query($sql_rank) or die(mysql_error());
	
	
	while ($r_rank = mysql_fetch_array($q_rank)) {
		$r_no = small_query("SELECT (COUNT(*) + 1) AS no FROM uts_rank WHERE gid= '${r_rank['gid']}' and rank > ". get_dp($r_rank['rank']) ."9");
		$result .=	'<TR><TD><B>Rank '.$r_rank['gamename'].'</B></TD><TD class=q_entry>'.RankImageOrTextFix($r_rank['pid'], $name, $r_no['no'], $r_rank['gid'], $r_rank['gamename'], false, '%IT%').' '.RankMovementFix($r_rank['rank'] - $r_rank['prevrank']).' ('.get_dp($r_rank['rank']).')</TD></TR>';
	}
	
	$result .= '</TABLE>';
	$result .= '<BR><P><A HREF="'.$url_fix.'/?p=pinfo&amp;pid='.$pid.'">All personal stats</A></P>';
	$result .= '<BR><P class=q_title>Recent games</P><P><TABLE class=q_info>';
	
	$sql_recent = "SELECT m.id, m.time, g.name AS gamename, m.mapfile, INET_NTOA(p.ip) AS ip FROM uts_match m, uts_player p, uts_games g
	WHERE p.pid = '$pid' AND m.id = p.matchid AND m.gid = g.id ORDER BY time DESC LIMIT 0,3";
	$q_recent = mysql_query($sql_recent) or die(mysql_error());
	while ($r_recent = mysql_fetch_array($q_recent)) {
	
		  $r_time = mdate($r_recent[time]);
		  $r_mapfile = un_ut($r_recent[mapfile]);
	
		  $result .= '
		  <tr>
			<td class="q_entry"><a class="darkhuman" href="'.$url_fix.'/?p=match&amp;mid='.$r_recent[id].'">'.$r_time.'</a></td>
			<td class="q_entry">'.$r_recent[gamename].'</td>
			<td class="q_entry">'.$r_mapfile.'</td>
		  </tr>';
	}
	
	$result .= '</TABLE>';
	
	echo $result;
}
?>
